// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.faces.application.FacesMessage;
import jakarta.faces.component.behavior.ClientBehaviorHolder;
import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIMessages;
import org.apache.myfaces.tobago.layout.OrderBy;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import jakarta.faces.application.ProjectStage;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 Renders error/validation messages.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.MessagesTagDeclaration}.
 */
@Generated("component.stg")
public class UIMessages
    extends AbstractUIMessages implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.messages;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Messages";


  enum PropertyKeys {
    minSeverity,
    maxNumber,
    markup,
    customClass,
    orderBy,
    confirmation,
    maxSeverity,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Sets the minimum severity to be shown. E.g. "warn" shows only "warn", "error" and "fatal".
  <br>Default: <code>info</code>
  */
  public jakarta.faces.application.FacesMessage.Severity getMinSeverity() {
    jakarta.faces.application.FacesMessage.Severity minSeverity = (jakarta.faces.application.FacesMessage.Severity) getStateHelper().eval(PropertyKeys.minSeverity);
    if (minSeverity != null) {
      return minSeverity;
    }
    return jakarta.faces.application.FacesMessage.SEVERITY_INFO;
  }

  public void setMinSeverity(jakarta.faces.application.FacesMessage.Severity minSeverity) {
    getStateHelper().put(PropertyKeys.minSeverity, minSeverity);
  }

  /**
  Sets the maximum number of messages to show.
  <br>Default: <code>2147483647</code>
  */
  public java.lang.Integer getMaxNumber() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.maxNumber);
    if (value != null) {
      return value.intValue();
    }
    return 2147483647;
  }

  public void setMaxNumber(java.lang.Integer maxNumber) {
    getStateHelper().put(PropertyKeys.maxNumber, maxNumber);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Sets the order of the messages.
  <br>Default: <code>occurrence</code><br>Allowed Values: <code>occurrence,severity</code>
  */
  public org.apache.myfaces.tobago.layout.OrderBy getOrderBy() {
    org.apache.myfaces.tobago.layout.OrderBy orderBy = (org.apache.myfaces.tobago.layout.OrderBy) getStateHelper().eval(PropertyKeys.orderBy);
    if (orderBy != null) {
      return orderBy;
    }
    return org.apache.myfaces.tobago.layout.OrderBy.occurrence;
  }

  public void setOrderBy(org.apache.myfaces.tobago.layout.OrderBy orderBy) {
    getStateHelper().put(PropertyKeys.orderBy, orderBy);
  }

  /**
  Has the user to confirm this message?
   This attributes handles the case, if the application wants to warn the user about a problem,
   and the user has to confirm the message before he/she can continue.
  <br>Default: <code>false</code>
  */
  public boolean isConfirmation() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.confirmation);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setConfirmation(boolean confirmation) {
    getStateHelper().put(PropertyKeys.confirmation, confirmation);
  }

  /**
  Sets the maximum severity to be shown. E.g. "warn" shows only "warn" and "info".
   When setting this attribute you usually should take care, that you have a second message tag to show the
   higher severity levels.
  <br>Default: <code>fatal</code>
  */
  public jakarta.faces.application.FacesMessage.Severity getMaxSeverity() {
    jakarta.faces.application.FacesMessage.Severity maxSeverity = (jakarta.faces.application.FacesMessage.Severity) getStateHelper().eval(PropertyKeys.maxSeverity);
    if (maxSeverity != null) {
      return maxSeverity;
    }
    return jakarta.faces.application.FacesMessage.SEVERITY_FATAL;
  }

  public void setMaxSeverity(jakarta.faces.application.FacesMessage.Severity maxSeverity) {
    getStateHelper().put(PropertyKeys.maxSeverity, maxSeverity);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}